## node-shiny-server 1.5.20.1002

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.10)

project(shiny-server)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bin")

if ("$ENV{BUILD_NUMBER}" STREQUAL "")
  set(BUILD_NUMBER "0")
else()
  set(BUILD_NUMBER $ENV{BUILD_NUMBER})
endif()

# Extract the shiny-server version number from package.json
execute_process(COMMAND sed -n "s/\\s*\"version\": \"\\(.*\\)\",\\s*/\\1/p"
                INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/package.json"
                OUTPUT_VARIABLE NPM_PACKAGE_VERSION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
# Parse major, minor, and patch values from NPM_PACKAGE_VERSION
STRING(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)"
       "\\1" CPACK_PACKAGE_VERSION_MAJOR ${NPM_PACKAGE_VERSION})
STRING(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)"
       "\\2" CPACK_PACKAGE_VERSION_MINOR ${NPM_PACKAGE_VERSION})
STRING(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)"
       "\\3" CPACK_PACKAGE_VERSION_PATCH ${NPM_PACKAGE_VERSION})

set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.${BUILD_NUMBER}")

execute_process(COMMAND git describe --tags --dirty
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/GIT_VERSION")
execute_process(COMMAND echo "${CPACK_PACKAGE_VERSION}"
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/VERSION")

add_subdirectory(src)
add_subdirectory(external/pandoc)

install(DIRECTORY assets
                  samples                  
                  build
                  config
                  ext
                  lib
                  manual.test
                  node_modules
                  python
                  R
                  scripts
                  templates
                  test
                  tools
        USE_SOURCE_PERMISSIONS DESTINATION shiny-server)


# Configure and assemble /bin directory.
configure_file(bin/deploy-example.in bin/deploy-example)
install(PROGRAMS bin/node
                 bin/npm
                 bin/shiny-server
                 "${CMAKE_CURRENT_BINARY_DIR}/bin/deploy-example"
        DESTINATION shiny-server/bin)

# Render and rename NOTICE.md
execute_process(COMMAND cat 
                INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/NOTICE.md
                OUTPUT_FILE ${CMAKE_CURRENT_BINARY_DIR}/NOTICE)

install(FILES binding.gyp
              config.html
              COPYING
              NEWS
              package.json
              README.md
              "${CMAKE_CURRENT_BINARY_DIR}/NOTICE"
              "${CMAKE_CURRENT_BINARY_DIR}/VERSION"
              "${CMAKE_CURRENT_BINARY_DIR}/GIT_VERSION"
        DESTINATION shiny-server)


set(CPACK_PACKAGE_NAME "shiny-server")
set(CPACK_PACKAGE_DESCRIPTION "Shiny Server")
set(CPACK_PACKAGE_VENDOR "RStudio, Inc.")
set(CPACK_PACKAGE_CONTACT "RStudio <info@rstudio.com>")
#set(CPACK_PACKAGE_INSTALL_DIRECTORY "Shiny Server")

# == Linux packaging directives ==

# configure cpack install location
set(CPACK_SET_DESTDIR "ON")
set(CPACK_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")

# detect architecture (packaging platform specific)
find_program(DPKG_EXECUTABLE dpkg)
find_program(RPM_EXECUTABLE rpm)
if (NOT PACKAGE_ARCHITECTURE)
   if(DPKG_EXECUTABLE)
      exec_program(dpkg ARGS --print-architecture
                   OUTPUT_VARIABLE PACKAGE_ARCHITECTURE)
      set(PACKAGE_DIST "")
   elseif(RPM_EXECUTABLE)
      #RHEL/CentOS/SuSE
      exec_program(arch OUTPUT_VARIABLE PACKAGE_ARCHITECTURE) 
      set(PACKAGE_DIST "")
   endif()
endif()

# debian control files
set(DEBIAN_POSTINST postinst.in)
set(DEBIAN_PRERM prerm.in)
set(DEBIAN_POSTRM postrm.in)

# rpm scripts
set(RPM_POSTTRANS posttrans.sh.in)
set(RPM_POSTINST postinst.sh.in)
set(RPM_POSTRM postrm.sh.in)

# debian dependencies -- to install the .deb from the command line with
# automatic dependency resolution use e.g.
#   sudo apt-get install gdebi-core
#   sudo gdebi shiny-server-<version>-amd64.deb

# define package suffix
set(SHINY_SERVER_PACKAGE_SUFFIX "-")

# include overlay if it exists
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/CMakeOverlay.txt")
   include(CMakeOverlay.txt)
endif()

# dynamically configured debian control scripts
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian-control/${DEBIAN_POSTINST}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postinst)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian-control/${DEBIAN_PRERM}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/prerm)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian-control/${DEBIAN_POSTRM}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postrm)

set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postinst;${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/prerm;${CMAKE_CURRENT_BINARY_DIR}/packaging/debian-control/postrm")

# dynamically configured rpm scripts (only works with cmake 2.8.1 or higher). 
# alternatively you can get CPackRPM.cmake from the cmake tip and copy it into
# your local cmake modules directory -- this is what we currently do
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/rpm-script/${RPM_POSTTRANS}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/posttrans.sh)
file(READ ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/posttrans.sh RPM_POSTTRANS_SCRIPT)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/rpm-script/${RPM_POSTINST}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postinst.sh)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/packaging/rpm-script/${RPM_POSTRM}
               ${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postrm.sh)

# Magic to prevent static pandoc binaries from breaking
set(CPACK_RPM_SPEC_INSTALL_POST "/bin/true")

set(CPACK_RPM_PACKAGE_AUTOREQPROV " no")

# Work-around bug in CMake 2.8.10.2		
set(CPACK_RPM_SPEC_MORE_DEFINE "%define ignore \#")		
set(CPACK_RPM_USER_FILELIST    "%ignore /opt")

set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE "${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postinst.sh")
set(CPACK_RPM_POST_UNINSTALL_SCRIPT_FILE "${CMAKE_CURRENT_BINARY_DIR}/packaging/rpm-script/postrm.sh")

# package file name
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}${SHINY_SERVER_PACKAGE_SUFFIX}${CPACK_PACKAGE_VERSION}${PACKAGE_DIST}-${PACKAGE_ARCHITECTURE}")
string(TOLOWER "${CPACK_PACKAGE_FILE_NAME}" CPACK_PACKAGE_FILE_NAME)

# variables to be re-used in package description fields
set(PACKAGE_LONG_DESCRIPTION "Shiny Server is a server program from RStudio, Inc. that makes Shiny applications available over the web. Shiny is a web application framework for the R statistical computation language.")

# debian-specific
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION}\n ${PACKAGE_LONG_DESCRIPTION}")
set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "${PACKAGE_ARCHITECTURE}")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "lsb-release, libc6 (>= 2.7)")
set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "r-base (>= 2.15.1)")

# rpm-specific
set(CPACK_RPM_PACKAGE_SUMMARY "${CPACK_PACKAGE_NAME}")
set(CPACK_RPM_PACKAGE_DESCRIPTION "${PACKAGE_LONG_DESCRIPTION}")
set(CPACK_RPM_PACKAGE_LICENSE "AGPL v.3.0")
set(CPACK_RPM_PACKAGE_GROUP "System Environment/Daemons")
set(CPACK_RPM_PACKAGE_ARCHITECTURE "${PACKAGE_ARCHITECTURE}")
set(CPACK_RPM_PACKAGE_REQUIRES "")


include(CPack)

=== src/CMakeLists.txt ===
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/launcher.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/launcher.h")
add_executable(shiny-server launcher.cc)

=== external/pandoc/CMakeLists.txt ===
project(pandoc)

set(PANDOC_VERSION 1.19.2.1)

set(PANDOC_DOWNLOADS
    # Format: filename (minus .gz), then colon, then SHA1 hash.
    # Modify the hash values whenever PANDOC_VERSION changes.
    # You can get the new hash values by not updating the values
    # and running the make-package.sh script; the error logs will
    # tell you what the actual hash values were.
    "pandoc:159438262cd1c0d5a6d5d50db53251d209aa5018"
    "pandoc-citeproc:50dd59d4eb1770bb2a17c0e1a0b16cce9f3edfd8")

# PANDOC_PREFIX is the final location that the extracted pandoc
# binaries will be placed: [basedir]/ext/pandoc/
get_filename_component(PANDOC_PREFIX 
    "${CMAKE_CURRENT_SOURCE_DIR}/../../ext/pandoc"
    REALPATH)
file(MAKE_DIRECTORY ${PANDOC_PREFIX})

foreach(DOWNLOAD_INFO ${PANDOC_DOWNLOADS})
    # CMake "lists" are simply semicolon-delimited strings. Convert
    # our colon-delimited strings to a CMake list.
    string(REPLACE ":" ";" DL ${DOWNLOAD_INFO})
    # Extract the first and second elements into CURRENT_FILENAME and
    # CURRENT_SHA CMake variables.
    list(GET DL 0 CURRENT_FILENAME)
    list(GET DL 1 CURRENT_SHA)

    set(DOWNLOAD_DEST "${CMAKE_CURRENT_BINARY_DIR}/${CURRENT_FILENAME}.gz")
    set(GUNZIP_DEST "${CMAKE_CURRENT_BINARY_DIR}/${CURRENT_FILENAME}")

    if (EXISTS "${DOWNLOAD_DEST}")
        # If the file was downloaded in the past, check if it's the
        # right file by verifying the SHA1 hash. If it's not the right
        # file then warn and delete it, then continue (it will download).
        file(SHA1 "${DOWNLOAD_DEST}" PANDOC_SHA1_ACTUAL)
        if (NOT "${CURRENT_SHA}" STREQUAL "${PANDOC_SHA1_ACTUAL}")
            message(WARNING "${CURRENT_FILENAME}.gz hash mismatch: expected ${CURRENT_SHA}, actual ${PANDOC_SHA1_ACTUAL}")
            file(REMOVE "${DOWNLOAD_DEST}")
        endif()
    endif()

    if (NOT EXISTS "${DOWNLOAD_DEST}")
        # If the file doesn't exist (or it did exist but had the wrong
        # SHA1 sum, so we deleted it) then download and verify it.
        message(STATUS "Downloading ${CURRENT_FILENAME}")
        file(DOWNLOAD
            "http://s3.amazonaws.com/rstudio-buildtools/pandoc/${PANDOC_VERSION}/linux-64/${CURRENT_FILENAME}.gz"
            "${DOWNLOAD_DEST}"
            SHOW_PROGRESS
            EXPECTED_HASH SHA1=${CURRENT_SHA}
        )
    endif()

    # gunzip the downloaded (or cached) file. If the output file
    # already exists, get rid of it first so gunzip doesn't prompt.
    file(REMOVE "${GUNZIP_DEST}")
    message(STATUS "gunzip ${DOWNLOAD_DEST}")
    execute_process(COMMAND gunzip -c "${DOWNLOAD_DEST}"
        RESULT_VARIABLE UNZIP_RESULT
        OUTPUT_FILE "${GUNZIP_DEST}"
    )
    if (NOT ${UNZIP_RESULT} EQUAL 0)
        message(FATAL_ERROR "Failed to gunzip ${DOWNLOAD_DEST}")
    endif()

    # Copy and chmod the downloaded file
    file(COPY "${GUNZIP_DEST}"
        DESTINATION "${PANDOC_PREFIX}"
        FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    )

endforeach(DOWNLOAD_INFO)

## node-shiny-server 1.5.19.995

=== debian/changelog ===
node-shiny-server (1.5.19.995-1) unstable; urgency=medium

  * Team upload.
  * Change Maintainer to science team
  * New upstream version 1.5.19.995
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Refresh, re-diff patches
  * Add depend on python3
  * d/s/lintian-overrides: Update overrides
  * Add Depends on adduser

 -- Nilesh Patra <nilesh@debian.org>  Fri, 26 Aug 2022 20:35:00 +0530

node-shiny-server (1.5.17.973-3) unstable; urgency=medium

  * Team upload.
  * Trying luck with piuparts

  [ Andreas Tille ]
  * Try SHINYHOME=/var/lib/shiny

  [ Nilesh Patra ]
  * Pipe deluser, delgroup with true
  * Add NEWS entry for homedir change

 -- Nilesh Patra <nilesh@debian.org>  Wed, 25 May 2022 00:38:09 +0530

node-shiny-server (1.5.17.973-2) unstable; urgency=medium

  * Team upload.
  * Hack around, added patch to fix tests
  * Move to unstable

 -- Nilesh Patra <nilesh@debian.org>  Tue, 17 May 2022 23:23:29 +0530

node-shiny-server (1.5.17.973-1) experimental; urgency=medium

  * Team Upload.
  * Initial release (Closes: #960906)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 14 Apr 2022 11:53:26 +0530

=== debian/control ===
Source: node-shiny-server
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               mocha <!nocheck>,
               node-bash <!nocheck>,
               node-express <!nocheck>,
               node-faye-websocket <!nocheck>,
               node-graceful-fs <!nocheck>,
               node-handlebars <!nocheck>,
               node-log4js <!nocheck>,
               node-moment <!nocheck>,
               node-optimist <!nocheck>,
               node-pause <!nocheck>,
               node-q <!nocheck>,
               node-qs <!nocheck>,
               node-send <!nocheck>,
               node-should <!nocheck>,
               node-sinon <!nocheck>,
               node-split <!nocheck>,
               node-stable <!nocheck>,
               node-underscore <!nocheck>,
               node-compression <!nocheck>,
               node-client-sessions <!nocheck>,
               node-nan <!nocheck>,
               node-morgan <!nocheck>,
               node-mime <!nocheck>,
               node-shiny-server-client <!nocheck>,
               node-ip-address <!nocheck>,
               node-http-proxy <!nocheck>,
               node-rewire <!nocheck>,
               node-send (>= 0.18.0+~cs1.19.1-1~) <!nocheck>,
               nodejs,
               node-nan,
               node-gyp
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/shiny-server
Vcs-Git: https://salsa.debian.org/science-team/shiny-server.git
Homepage: https://www.rstudio.com/products/shiny/shiny-server/
Rules-Requires-Root: no

Package: shiny-server
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         r-base,
         r-cran-shiny,
         mocha,
         node-bash,
         node-express,
         node-faye-websocket,
         node-graceful-fs,
         node-handlebars,
         node-log4js,
         node-moment,
         node-optimist,
         node-pause,
         node-q,
         node-qs,
         node-send (>= 0.18.0+~cs1.19.1-1~),
         node-should,
         node-sinon,
         node-split,
         node-stable,
         node-underscore,
         node-compression,
         node-client-sessions,
         node-nan,
         node-morgan,
         node-shiny-server-client,
         node-ip-address,
         node-http-proxy,
         nodejs,
         npm,
         pandoc,
         python3,
         lsb-base,
         node-sockjs-client,
         node-sockjs
Description: put Shiny web apps online
 Shiny Server lets you put shiny web applications and interactive
 documents online. Take your Shiny apps and share them with your
 organization or the world.
 .
 Shiny Server lets you go beyond static charts, and lets you manipulate
 the data. Users can sort, filter, or change assumptions in real-time.
 Shiny server empower your users to customize your analysis for their
 specific needs and extract more insight from the data.

## node-shiny-server 1.5.20.1002

=== debian/changelog ===
node-shiny-server (1.5.20.1002-4) unstable; urgency=medium

  * Team upload.
  * Fix team name in d/control
  * Update Vcs tags to new Salsa name

 -- Alexandre Detiste <tchet@debian.org>  Sun, 06 Apr 2025 13:55:35 +0200

node-shiny-server (1.5.20.1002-3) unstable; urgency=medium

  * Team Upload.
  * Add patch to fixup FTBFS (Closes: #1082688)
  * Bump Standards-Version to 4.7.0 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 08 Nov 2024 01:18:42 +0530

node-shiny-server (1.5.20.1002-2) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Team upload.
  * Fix init script.
    Thanks to Stephan Hachinger (Closes: #1053526)

  [ Helmut Grohne ]
  * Install systemd unit only once (Closes: #1054481)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 27 Oct 2023 14:08:57 +0200

node-shiny-server (1.5.20.1002-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 1.5.20.1002
  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Tighten dependency on sockjs
  * Drop depends on lsb-base

 -- Nilesh Patra <nilesh@debian.org>  Fri, 24 Feb 2023 00:37:13 +0530

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: node-shiny-server
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Shayan Doust <hello@shayandoust.me>
 Section: science
@@ -37,9 +37,9 @@
                nodejs,
                node-nan,
                node-gyp
-Standards-Version: 4.6.1
-Vcs-Browser: https://salsa.debian.org/science-team/shiny-server
-Vcs-Git: https://salsa.debian.org/science-team/shiny-server.git
+Standards-Version: 4.7.0
+Vcs-Browser: https://salsa.debian.org/science-team/node-shiny-server
+Vcs-Git: https://salsa.debian.org/science-team/node-shiny-server.git
 Homepage: https://www.rstudio.com/products/shiny/shiny-server/
 Rules-Requires-Root: no
 
@@ -79,9 +79,8 @@
          npm,
          pandoc,
          python3,
-         lsb-base,
          node-sockjs-client,
-         node-sockjs
+         node-sockjs (>= 0.3.24+~0.3.33-6~)
 Description: put Shiny web apps online
  Shiny Server lets you put shiny web applications and interactive
  documents online. Take your Shiny apps and share them with your

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/rstudio/shiny-server/tags .*/v?([\d\.]+)\.tar\.gz
